function love.run()
	--local love = love
	love.window.updateMode(1044, 48, {vsync = false})
	local own = {}
	own.keysimg = love.graphics.newImage("keys.png")
	-- audio stream test
	own.keyActimg = love.graphics.newImage("keys_active.png")
	own.keysPlay = {}
	for _ = 0, 119 do own.keysPlay[_] = false end
	own.keyClick = false
	own.keyAc = 0
	own.mouseX = 0
	own.mouseY = 0
	
	local str={}
	str.buffersAmount = 12  --<<--- Set amount of buffers here
	str.bufferSize = 250  --<<---Set the size of the buffer here
	str.stream = love.audio.newQueueableSource(48000, 16, 2, str.buffersAmount)
	str.buffers = {}
	for id = 1, str.buffersAmount do table.insert(str.buffers, love.sound.newSoundData(str.bufferSize, 48000, 16, 2)) end
	str.wave = love.sound.newSoundData("02.wav")
	str.waveLenght = 28  --<<--- Set sample lenght here (divided by 16)
	str.waveLoop = 3  --<<--- Set loop size here (divided by 16)
	str.waveCycles = 4  --<<--- Set cycles in loop here
	str.wavePlay = false
	str.waveSemitone = 0
	str.waveFineTune = 0
	str.wavePosition = -1
	str.interpolationLevel = 32  --<<--- Set here how many interpolation points to use (4 for 8-point, 8 for 16-point)
	str.extractedSample = 0
	str.loopingStarted = false
	str.endedWave = false
	
	str.waveLenght = str.waveLenght * 16
	str.waveRewindStart = str.waveLenght - str.waveLoop * 16
	
	s_ = love.graphics.newCanvas(1044,576)
	
	return function()
		love.timer.step() -- for FPS only
		love.event.pump()
		for a, b, c, d in love.event.poll() do
			if a == "mousemoved" then
				c = c + 528
				own.mouseX = b
				own.mouseY = c
			elseif a == "mousepressed" then
				c = c + 528
				if d == 1 then
					if b < 980 and c > 527 then
						own.keyClick = true
						str.wavePlay = true
						own.mouseX = b
						own.mouseY = c
					end
				end
			elseif a == "mousereleased" then
				c = c + 528
				if d == 1 then
					own.keyClick = false
					str.wavePlay = false
				end
			elseif a == "quit" then return 0
			end
		end
		-- drawing start
		love.graphics.setCanvas(s_)
		love.graphics.clear(0.125, 0.125, 0.125, 1)
		if true then
			-- clicking on keys
			do
			own.keysPlay[own.keyAc] = false
			if own.keyClick then
				own.keyAc = math.floor(own.mouseX / 98)*12
				extraKey1 = math.floor(own.mouseX / 14)%7
				own.keyAc = own.keyAc + extraKey1*2
				if extraKey1 > 2 then own.keyAc = own.keyAc - 1 end
				--print(extraKey1)
				if own.mouseY < 555 then
					extraKey2 = own.mouseX-7
					extraKey3 = math.floor(extraKey2 / 14)%7
					extraKey2 = (extraKey2)%14
					if extraKey3 == 0 or extraKey3 == 3 then
						if extraKey2 < 11 and extraKey2 > 0 then
							own.keyAc = own.keyAc + (extraKey2 > 6 and -1 or 1)
						end
				elseif extraKey3 == 1 or extraKey3 == 5 then
						if extraKey2 < 13 and extraKey2 > 2 then
							own.keyAc = own.keyAc + (extraKey2 > 6 and -1 or 1)
						end
				elseif extraKey3 == 4 then
						if extraKey2 < 12 and extraKey2 > 1 then
							own.keyAc = own.keyAc + (extraKey2 > 6 and -1 or 1)
						end
					end
				end
				if own.keyAc > 119 then own.keyAc = 119 end
				own.keysPlay[own.keyAc] = true
				str.waveSemitone = own.keyAc-9
			end
			end
			
			
			--[[************************************************************]]
			---***                   Audio Streaming                    ***---
				for id = 1, str.stream:getFreeBufferCount() do
					for j = 0, str.bufferSize - 1 do
						str.extractedSample = 0
						if str.wavePlay and (not(str.endedWave)) then
							if str.wavePosition == -1 then
								str.wavePosition = 0
							else
								str.wavePosition = str.wavePosition + 
								
									--[[  Time Formula  ]]--
										str.waveLoop*11/(str.waveCycles*1200) * 2^(str.waveSemitone/12+str.waveFineTune/768)
									------------------------
									
								while str.wavePosition >= str.waveLenght do
									if str.waveLoop == 0 then
										str.endedWave = true
										str.wavePosition = -1
									else
										str.loopingStarted = true
										str.wavePosition = str.wavePosition - str.waveLenght + str.waveRewindStart
									end
								end
							end
							if not str.endedWave then
								for point = -str.interpolationLevel, str.interpolationLevel do
									if point ~= 0 then
										if (not(math.floor(str.wavePosition) + point < 0)) then
											if str.wavePosition - math.floor(str.wavePosition) == 0 then
												positionC = math.floor(str.wavePosition)
												str.extractedSample = 
												
												--[[  No Interpolation Formula (for x == 0) (apparently rarely happens)]]--
													str.wave:getSample(positionC)
												---------------------------------
												
											else
												if point < 0 then
													positionA = str.wavePosition - math.floor(str.wavePosition) - point - 1
													positionC = math.ceil(str.wavePosition) + point
												else
													positionA = -(math.ceil(str.wavePosition) - str.wavePosition) - point + 1
													positionC = math.floor(str.wavePosition) + point
												end
												while str.loopingStarted and positionC < str.waveRewindStart do
													positionC = str.waveLenght - (str.waveRewindStart - positionC)
												end
												while positionC >= str.waveLenght do
													positionC = positionC - str.waveLenght + str.waveRewindStart
												end
												positionA = positionA * math.pi
												positionB = positionA / str.interpolationLevel
												
												str.extractedSample = str.extractedSample +
												
												--[[  Interpolation Formula (for x ~= 0) ]]--
													math.sin(positionA)*math.sin(positionB)*str.wave:getSample(positionC)/(positionA*positionB)
												---------------------------------
												
											end
										end
									end
								end
							end
							--print(str.wavePosition)
						else
							str.wavePosition = -1
							str.loopingStarted = false
							str.endedWave = false
						end
						--print(str.wavePosition)
						str.buffers[id]:setSample(j, 1, str.extractedSample)
						str.buffers[id]:setSample(j, 2, str.extractedSample)
					end
					str.stream:queue(str.buffers[id])
				end
				str.stream:play()
			--[[************************************************************]]
			
			
		end
		---------------------------
		love.graphics.draw(own.keysimg, 0, 528)
		-- drawing active keys
		for id = 0, 119 do
			if own.keysPlay[id] then
				love.graphics.setScissor(math.floor(id/12)*98 +   (id%12>4 and math.floor((id%12-5)/2)%4+3 or math.floor(id/2)%6)   *14, 528, 20, 48)
				love.graphics.draw(own.keyActimg, math.floor(id/12)*98 - id%12*20 +   (id%12>4 and math.floor((id%12-5)/2)%4+3 or math.floor(id/2)%6)     *14, 528)
				love.graphics.setScissor()
			end
		end
		love.graphics.print(love.timer.getFPS(), 994, 544)
		love.graphics.setCanvas()
		love.graphics.draw(s_, 0, -528)
		love.graphics.present()
	end
end